View Javadoc

    1   /*
    2    *  Licensed to the Apache Software Foundation (ASF) under one
    3    *  or more contributor license agreements.  See the NOTICE file
    4    *  distributed with this work for additional information
    5    *  regarding copyright ownership.  The ASF licenses this file
    6    *  to you under the Apache License, Version 2.0 (the
    7    *  "License"); you may not use this file except in compliance
    8    *  with the License.  You may obtain a copy of the License at
    9    *
    10   *    http://www.apache.org/licenses/LICENSE-2.0
    11   *
    12   *  Unless required by applicable law or agreed to in writing,
    13   *  software distributed under the License is distributed on an
    14   *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    15   *  KIND, either express or implied.  See the License for the
    16   *  specific language governing permissions and limitations
    17   *  under the License.
    18   *
    19   */
    20  package org.apache.mina.proxy.handlers.socks;
    21
    22  import java.util.Arrays;
    23
    24  import org.apache.mina.core.buffer.IoBuffer;
    25  import org.apache.mina.core.filterchain.IoFilter.NextFilter;
    26  import org.apache.mina.proxy.session.ProxyIoSession;
    27  import org.apache.mina.proxy.utils.ByteUtilities;
    28  import org.slf4j.Logger;
    29  import org.slf4j.LoggerFactory;
    30
    31  /**
    32   * Socks4LogicHandler.java - SOCKS4/SOCKS4a authentication mechanisms logic handler.
    33   *
    34   * @author <a href="http://mina.apache.org">Apache MINA Project</a>
    35   * @since MINA 2.0.0-M3
    36   */
    37  public class Socks4LogicHandler extends AbstractSocksLogicHandler {
    38
    39      private final static Logger logger = LoggerFactory.getLogger(Socks4LogicHandler.class);
    40
    41      /**
    42       * {@inheritDoc}
    43       */
    44      public Socks4LogicHandler(final ProxyIoSession proxyIoSession) {
    45          super(proxyIoSession);
    46      }
    47
    48      /**
    49       * Perform the handshake.
    50       *
    51       * @param nextFilter the next filter
    52       */
    53      public void doHandshake(final NextFilter nextFilter) {
    54          logger.debug(" doHandshake()");
    55
    56          // Send request
    57          writeRequest(nextFilter, request);
    58      }
    59
    60      /**
    61       * Encode a SOCKS4/SOCKS4a request and writes it to the next filter
    62       * so it can be sent to the proxy server.
    63       *
    64       * @param nextFilter the next filter
    65       * @param request the request to send.
    66       */
    67      protected void writeRequest(final NextFilter nextFilter, final SocksProxyRequest request) {
    68          try {
    69              boolean isV4ARequest = Arrays.equals(request.getIpAddress(), SocksProxyConstants.FAKE_IP);
    70              byte[] userID = request.getUserName().getBytes("ASCII");
    71              byte[] host = isV4ARequest ? request.getHost().getBytes("ASCII") : null;
    72
    73              int len = 9 + userID.length;
    74
    75              if (isV4ARequest) {
    76                  len += host.length + 1;
    77              }
    78
    79              IoBuffer buf = IoBuffer.allocate(len);
    80
    81              buf.put(request.getProtocolVersion());
    82              buf.put(request.getCommandCode());
    83              buf.put(request.getPort());
    84              buf.put(request.getIpAddress());
    85              buf.put(userID);
    86              buf.put(SocksProxyConstants.TERMINATOR);
    87
    88              if (isV4ARequest) {
    89                  buf.put(host);
    90                  buf.put(SocksProxyConstants.TERMINATOR);
    91              }
    92
    93              if (isV4ARequest) {
    94                  logger.debug("  sending SOCKS4a request");
    95              } else {
    96                  logger.debug("  sending SOCKS4 request");
    97              }
    98
    99              buf.flip();
    100             writeData(nextFilter, buf);
    101         } catch (Exception ex) {
    102             closeSession("Unable to send Socks request: ", ex);
    103         }
    104     }
    105
    106     /**
    107      * Handle incoming data during the handshake process. Should consume only the
    108      * handshake data from the buffer, leaving any extra data in place.
    109      *
    110      * @param nextFilter the next filter
    111      * @param buf the server response data buffer
    112      */
    113     public void messageReceived(final NextFilter nextFilter, final IoBuffer buf) {
    114         try {
    115             if (buf.remaining() >= SocksProxyConstants.SOCKS_4_RESPONSE_SIZE) {
    116                 handleResponse(buf);
    117             }
    118         } catch (Exception ex) {
    119             closeSession("Proxy handshake failed: ", ex);
    120         }
    121     }
    122
    123     /**
    124      * Handle a SOCKS4/SOCKS4a response from the proxy server. Test
    125      * the response buffer reply code and call {@link #setHandshakeComplete()}
    126      * if access is granted.
    127      *
    128      * @param buf the buffer holding the server response data.
    129      * @throws exception if server response is malformed or if request is rejected
    130      * by the proxy server.
    131      */
    132     protected void handleResponse(final IoBuffer buf) throws Exception {
    133         byte first = buf.get(0);
    134
    135         if (first != 0) {
    136             throw new Exception("Socks response seems to be malformed");
    137         }
    138
    139         byte status = buf.get(1);
    140
    141         // Consumes all the response data from the buffer
    142         buf.position(buf.position() + SocksProxyConstants.SOCKS_4_RESPONSE_SIZE);
    143
    144         if (status == SocksProxyConstants.V4_REPLY_REQUEST_GRANTED) {
    145             setHandshakeComplete();
    146         } else {
    147             throw new Exception("Proxy handshake failed - Code: 0x" + ByteUtilities.asHex(new byte[] { status }) + " ("
    148                     + SocksProxyConstants.getReplyCodeAsString(status) + ")");
    149         }
    150     }
    151 }